/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"
#include "DBResultSet.h"
#include "Serializer.h"

#pragma once

namespace SLK
{

class Database;

class DBStatement
{
public:
	DBStatement(sqlite3 *database);
	DBStatement(Database *database);
	virtual ~DBStatement(void);
	void prepare(std::string sqlStatement);
	void prepareAndRun(std::string sqlStatement);
	void bind(std::string name, float val);
	void bind(std::string name, double val);
	void bind(std::string name, int val);
	void bind(std::string name, __int64 val);
	void bind(std::string name, std::string val);
	void bind(std::string name, SLK::Serializer &serializer);//Binds a blob
	void bind(std::string name, void* blob, int size);

	void run(DBResultSet *results = 0);
	void reset();
	void clear();
private:
	int getParamIndex(std::string paramName);

	sqlite3_stmt* m_statement;
	sqlite3* m_database;
};

}
