/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once
#include "sqlite3.h"
#include "Sequencer.h"

namespace SLK
{

class Database
{
public:
	Database();
	virtual ~Database(void);

	void open(std::string fileName);
	void close();
	bool tableExists(std::string tableName);

	sqlite3* getSQLite(){return m_database;}

	static std::string getSaveFolder();

	Sequencer *getSequencer(std::string tableName, std::string idRow);

	unsigned int getLastInsertRow(){return sqlite3_last_insert_rowid(m_database);};
private:

	std::map<std::string, Sequencer*> m_sequencers;
	sqlite3* m_database;
};

}