/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once

namespace SLK
{

struct SerilynExport IntVector
{
	IntVector(int x, int y){this->x=x; this->y=y;};
	IntVector(){this->x=0; this->y=0;};

	int x;
	int y;

    inline bool operator == ( const IntVector& rkVector ) const
    {
        return ( x == rkVector.x && y == rkVector.y);
    }

    inline bool operator != ( const IntVector& rkVector ) const
    {
        return ( x != rkVector.x || y != rkVector.y );
    }

   // arithmetic operations
    inline IntVector operator + ( const IntVector& rkVector ) const
    {
        return IntVector(
            x + rkVector.x,
            y + rkVector.y);
    }

    inline IntVector operator - ( const IntVector& rkVector ) const
    {
        return IntVector(
            x - rkVector.x,
            y - rkVector.y);
    }

	inline Ogre::Real length () const
    {
		return Ogre::Math::Sqrt( x * x + y * y);
    }

	inline Ogre::Real distanceSquared( const IntVector& rkVector ) const
    {
		IntVector vec = (*this)-rkVector;
		return  vec.x * vec.x + vec.y * vec.y;
    }

	inline IntVector& operator = ( const IntVector& rkVector )
	{
		x = rkVector.x;
		y = rkVector.y;

		return *this;
	}

    inline bool operator <( const IntVector& rkVector ) const
    {
        if ( x != rkVector.x)
			return ( x < rkVector.x);

		return ( y < rkVector.y);
    }

};

}