#ifndef MESSAGEBOX_H
#define MESSAGEBOX_H

#include <string>
#include <CEGUI.h>
#include "Event.h"

#ifdef MessageBox
#undef MessageBox
#endif

namespace SLK
{

class MessageBox
{
public:
	MessageBox(std::string title, std::string icon, std::string font, std::string text, std::string button1Text, std::string button2Text="", std::string button3Text="", std::string button4Text="");

	void show();//returns number of button clicked.
	void subscribeButtonEvent(unsigned int num, Event *event){assert(num<4);m_buttonEvents[num]=event;};

	virtual ~MessageBox(void);

private:
	virtual bool CloseWindow(const CEGUI::EventArgs &args);

	CEGUI::Window *m_screen;
	unsigned int m_numButtons;
	CEGUI::Window *m_buttons[4];
	Event *m_buttonEvents[4];

	static const float ICON_SIZE;
	static const float BUFFER_SIZE;
	static const float BUTTON_LENGTH;
	static const float BUTTON_HEIGHT;
	static const float DESCRIPTION_HEIGHT;

	static unsigned int m_numCtr;
};

}

#endif