/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once
#include "CEGUI.h"
#include "Ogre.h"
#include "Platform.h"

namespace SLK
{

// Class that will link a CEGUI window with a scene node's position on screen
class SerilynExport ScreenWindow
{
public:
	//If useBoundingBox is true the window will center above the bounding box,
	//otherwise it will center on the scene node
	//farDistance will hide the window if the attach position is that distance away or further.
	ScreenWindow(CEGUI::Window *window, Ogre::SceneNode *node, bool useBoundingBox = true, int farDistance = 50);
	virtual ~ScreenWindow(void);

	void update();

	CEGUI::Window &getWindow();
private:
	Ogre::SceneNode *m_node;
	bool m_enabled;
	bool m_useBoundingBox;
	CEGUI::Window *m_window;
	int m_farDistanceSquared;
};

}