/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#pragma once
#include <vector>

namespace SLK
{

template <typename T>
class Vector2D
{
public:

	template <typename T>
	class VectorHelper
	{
	public:
		friend Vector2D;
		VectorHelper()
		{
		}

		const T operator[](int j) const
		{
			return m_vec[j];
		}

		T& operator[](int j)
		{
			return m_vec[j];
		}

	private:
		std::vector<T> m_vec;
	};

	Vector2D(int w, int h, T initialVal)
	{
		resize(w,h,initialVal);
	}

	virtual ~Vector2D(void)
	{
	}


	const VectorHelper<T> operator[](int i) const
	{
		return m_storage[i];
	}

	VectorHelper<T>& operator[](int i)
	{
		return m_storage[i];
	}

	int getWidth(){return m_width;};
	int getHeight(){return m_height;};

	void resize(int w, int h, T newVal)
	{
		m_storage.resize(w);
		for(int i=0; i<w; i++)
		{
			m_storage[i].m_vec.resize(h,newVal);
		}
		m_height = h;
		m_width = w;
	}

private:
	std::vector< VectorHelper<T> > m_storage;
	int m_width;
	int m_height;

};


}