#include "StdAfx.h"
#include "OgreResourcesHelper.h"
#include "Application.h"
#include "Scripting.h"

// much of the reload code came from http://www.ogre3d.org/tikiwiki/Reloading+materials+and+parsing+material+scripts&structure=Cookbook Public Domain

namespace SLK
{

OgreResourcesHelper::OgreResourcesHelper(void)
{
}


OgreResourcesHelper::~OgreResourcesHelper(void)
{
}

void OgreResourcesHelper::LoadRecursive(std::string folder, std::vector<SLK::ResourceInitializer>& resourceList)
{
	boost::filesystem::path worldFolder(folder);
	boost::filesystem::directory_iterator end_iterator;

	for(boost::filesystem::directory_iterator iter(worldFolder); iter!=end_iterator; iter++)
	{
		if(boost::filesystem::is_directory(iter->status()))
		{
			std::string filepath = iter->path().string();
			resourceList.push_back(ResourceInitializer(filepath, "FileSystem", "General"));
			LoadRecursive(filepath, resourceList);
		}
	}
}

void OgreResourcesHelper::Reload()
{
	Ogre::ResourceGroupManager *manager = Ogre::ResourceGroupManager::getSingletonPtr();
	Ogre::ResourceGroupManager::ResourceManagerIterator iter = manager->getResourceManagerIterator();

	while(iter.hasMoreElements())
	{
		Ogre::ResourceManager* resources = iter.getNext();
		resources->reloadAll();
	}
	
}

void OgreResourcesHelper::RegisterReloadScripts()
{
	Scripting::getSingleton().RegisterGlobalFunction("void ReloadResources()",asFUNCTIONPR(OgreResourcesHelper::Reload,(void),void),asCALL_CDECL);
}

}