/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"
#include "SoundManager.h"
#include "Ogre.h"
#include "Application.h"

namespace SLK
{

unsigned long SoundManager::m_nameCtr = 0;


SoundManager::SoundManager(void)
{
	m_soundManager = OgreOggSound::OgreOggSoundManager::getSingletonPtr();

	m_soundManager->init();


}

SoundManager::~SoundManager(void)
{
	m_soundManager->destroyAllSounds();

}

void SoundManager::playSound(std::string file,bool loop)
{
	OgreOggSound::OgreOggISound *sound = 0;
	if ( sound = OgreOggSound::OgreOggSoundManager::getSingletonPtr()->createSound("Click", "Click.ogg", false, false) )
	{
		sound->setMaxDistance(50);
		sound->setReferenceDistance(1);
		sound->play();
	}
}

void SoundManager::update(float deltaTime)
{
	OgreOggSound::OgreOggSoundManager::getSingletonPtr()->update(deltaTime);
}

//Creates a 3D sound
OgreOggSound::OgreOggISound *SoundManager::createSound(const std::string& name,const std::string& filename, bool stream, bool loop, bool preBuffer)
{
	std::stringstream strStr;
	strStr << name << "_" << m_nameCtr++;

	OgreOggSound::OgreOggISound *sound = OgreOggSound::OgreOggSoundManager::getSingletonPtr()->createSound(strStr.str(), filename, stream, loop, preBuffer);

	return sound;
}

//Creates a sound with 3D disabled
OgreOggSound::OgreOggISound *SoundManager::createCameraSound(const std::string& name,const std::string& file, bool stream, bool loop, bool preBuffer)
{
	OgreOggSound::OgreOggISound *sound = createSound(name,file,stream,loop,preBuffer);
	sound->disable3D(true);

	return sound;
}


}