
/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/
#include "StdAfx.h"
#include "Timer.h"

namespace SLK
{

Timer::Timer(void)
{
	m_lastTime = getMilliseconds();
	m_deltaTime=0;
}

Timer::~Timer(void)
{
}


void Timer::update()
{
	unsigned long curTime = getMilliseconds();
	unsigned long frameTime = curTime-m_lastTime;
	m_lastTime = curTime;
	m_deltaTime = frameTime * 0.001;
}


}