/*
-----------------------------------------------------------------------------
Copyright (c) 2009-2010 Sara Kempen

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
this program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
-----------------------------------------------------------------------------
*/

#include "StdAfx.h"
#include "exception.h"



namespace SLK
{

Exception::Exception(const char *text, ...)
{
	char formattedText[2024];     
	va_list varList;    

	// Expand the format string   
	va_start(varList, text);   
	vsprintf(formattedText, text, varList);   
	va_end(varList); 

	m_what = formattedText;
}

Exception::~Exception(void)
{
}

const char*Exception::what() const throw()
{
	return m_what.c_str();
}

}